void draw() {

  background(0);
  smooth();
  noStroke();
  graphicCorrection(); // needed if the projection is sideways


  if (data_list != null) {
  switch(mode){
    case 100:
    mode = 0;
    break;

  case 0:  //WAITING MODE
    if (data_list[0] == 1){ 
      mode = 1;
    }
    break;

  case 1: // FOREWARD
    steppings(); // CHECK THIS FUNCTION TO UNDERSTAND HOW THE FOOTSTEPS BASICALLY MOVE
    audioDistance(); // THIS FUNCTION CONTROLS THE AUDIO DISTANCE EFFECT
    distanceTimer(); // THIS FUNCTION CONTROLS THE TIME LAPS BETWEEN USER WALK AND GUIDE ONE (SLOW/FAST USER MODES)
    if (overSmartTime> millis() && distanceTimer == true && data_list[1] == 1){
      mode = 8;
    }
    if (overSmartTime< millis() && distanceTimer == true && data_list[1] == 1) {
      println("secondsensor");
      mode = 4;
    }
    break;

  case 2: //ROTATION FROM FRONT
    rotation();
    break;

  case 3: // BACK
    backSteppings();
    break;

  case 4: // AHEAD MODE
    steppings();
    break;

  case 5: // ROTATION FROM BACK
    backToFrontRotation();
    break;

  case 6: // AHEAD MODE IN SLOW USER CASE_PART 1 OF 2
    prints();
    secondFirstAhdead();
    //    println("bestia");
    break;

  case 7: // AHEAD MODE IN SLOW USER CASE_SECOND 2 OF 2
    prints();
    secondForeward();
    break;


  case 8: // FAST USER PART 1 OF 5
    firstAuch();
    break;

  case 9: // FAST USER PART 2 OF 5
    steppings();
    secondAuchTimer();
    break;

  case 10: // FAST USER PART 3 OF 5
    secondAuch();
    break;


  case 11: // FAST USER PART 4 OF 5
    steppings();
    thirdAuchTimer();
    break;


  case 12: // FAST USER PART 5 OF 5
    thirdAuch();
    break;


  case 18:  // DIRECTIONAL WHISTLE AT THE END OF THE SOTOPORTEGO_ NORMALE CASE
    if (finalWhistle == false) {
      finalWhistle = true;
      finalWhistleTime = millis();
    }
    if (millis() - finalWhistleTime > finalWhistleDelay && finalWhistle == true ) {
      whistle.pan(1);
      whistle.play();
      whistleCounter++;
    }
    if (timeToWhistleActv == false) {
      timeToWhistleActv = true;
      timeToWhistle = millis();
    }
    if (millis() - timeToWhistle> whistleDelay && timeToWhistleActv == true && whistleCounter > 1) {
      finalWhistle = false;
      timeToWhistleActv = false;
      mode = 20;
    }
    break;
    
  case 19:    // DIRECTIONAL WHISTLE AT THE END OF THE SOTOPORTEGO_ SLOW CASE
    if (finalWhistle == false) {
      finalWhistle = true;
      finalWhistleTime = millis();
    }
    if (millis() - finalWhistleTime > finalWhistleDelay && finalWhistle == true ) {
      whistle.pan(1);
      whistle.play();
      whistleCounter++;
    }
    if (whistleCounter > 1) {
      finalWhistle = false;
      mode = 20;
    }
    break;

  case 20:
    endApplication();
    break;


  }//switch closer
  } // ARDUINO MAIN IF CLOSE

 while (port.available() > 0){
    serialEvent(port.read());
  }
}//draw closer



///////////////////////THIS VOID IS NEEDED IN ORDER TO MAKE ARDUINO COMMUNICATES WITH PROCESSING
void serialEvent(int serial)
{
  
  if (serial != NEWLINE) {
    buff += char(serial);
  } 
  else {
    if (buff.length() > 0) {
      buff = buff.substring(0, buff.length()-1);
    }
    data = buff;
    data_list = int(split(data, ','));
    buff = "";
  }
}


/////////////////////////////////////////////////////
//////////THIS VOID DRAWS THE FOOTSTEPS,/////////////
//////////USEFUL TO KEEP THE CODE COMPACT////////////
//////////WHEN IS NEEDED TO CLEAR THE BACKGROUND/////
/////////////////////////////////////////////////////
void prints() {

  tint(255, LeftDim);
  imageMode(CENTER);
  image(left, LeftX, LeftY, (LeftWidth), (LeftHeight));
  tint(255, RightDim);
  imageMode(CENTER);
  image(right, RightX, RightY, RightWidth, RightHeight);
}


//////////////////////////////////////////////////////
////////////////WHEN THE WHOLE PROCESS IS COMPLETED///
///////////////THIS FUCTION RESET THE INSTALLATION//// 
///////////////FOR THE NEXT COMING USER///////////////
//////////////////////////////////////////////////////


void endApplication() {
  background(0);
  whistle.stop();
  Ess.stop(); 
  super.stop(); 
  mode = 0;
}

void graphicCorrection() {
  if (firstLeftCounter == 1 && distortionCounterRight == 0) {
    LeftWidth =38;
    LeftHeight = 29;
  }

  if (distortionCounterRight == 1){
    stepLenght = 190;
    RightWidth = 40;
    RightHeight = 30;
  }

  if (distortionCounterLeft == 1){
    stepLenght = 235;
    LeftWidth = 46;
    LeftHeight = 31;
  }

  if (distortionCounterRight == 2){
    stepLenght =255;
    RightWidth = 56;
    RightHeight = 35;
  }

  if (distortionCounterLeft == 2){
    stepLenght = 285;
    LeftWidth = 61;
    LeftHeight = 42;
  }  

  if (distortionCounterRight == 3){
    RightWidth = 62;
    RightHeight = 40;
  }

  if (distortionCounterLeft == 3){
    LeftWidth = 64;
    LeftHeight = 41;
  }  

  if (distortionCounterRight > 4 || distortionCounterLeft > 4){
    audio.stop();
    audio2.stop();
  }

  if (distortionCounterLeft == 2 && backMode != 5){
    LeftWidth = 59;
    LeftHeight = 34;
  }

  if (rotationFB == true && rotationFrontBack == 1) {
    LeftWidth = 59;
    LeftHeight = 34;
  }

  if (rotationFB == true && rotationFrontBack == 2) {
    RightWidth = 62;
    RightHeight = 31;
  }

  if (rotationFB == true && rotationFrontBack == 3) {
    LeftWidth = 63;
    LeftHeight = 32;
  }

  if (rotationFB == true && rotationFrontBack == 4) {
    RightWidth = 63;
    RightHeight = 35;
  }

  if (rotationFB == true && rotationFrontBack == 5) {
    RightWidth = 63;
    RightHeight = 35;
    LeftWidth = 63;
    LeftHeight = 35;
    stepLenght = 100;
  }

  if (backSteps == true && distortionBackLeftCounter == 1) {
    stepLenght = 160;
    LeftWidth = RightWidth = 55;
    LeftHeight = RightHeight = 34;
  }

  if (backSteps == true && distortionBackLeftCounter > 1) {
    stepLenght = 70;
    LeftWidth = RightWidth = 50;
    LeftHeight = RightHeight = 32;
  }

  if (rotationBF == true && backToFrontrotationMode == 1) {
    LeftWidth = 75;
    LeftHeight = 23;
  }

  if (rotationBF == true && backToFrontrotationMode == 2) {
    RightWidth = 45;
    RightHeight = 32;
  }

  if (rotationBF == true && backToFrontrotationMode == 3) {
    LeftWidth = 45;
    LeftHeight = 32;
  }

  if (rotationBF == true && backToFrontrotationMode == 4) {
    RightWidth = 45;
    RightHeight = 32;
    LeftWidth = 45;
    LeftHeight = 32;
    stepLenght = 210;
    println ("LX:"+ LeftX + ";" + "LY:" + LeftY + ";" + "RX:" + RightY);
  }

  if (mode == 6) {
    fade2();
    LeftX = 230;
    RightX = 230; 
    LeftY = 369;
    RightY = 369+36;
    stepLenght = 210;
    LeftWidth = 45;
    LeftHeight = 32;
  }

  if (RightSecondAheadCounter == 1) {
    stepLenght =255;
    RightWidth = 59;
    RightHeight =34 ;
  }

  if (LeftSecondAheadCounter == 1) {
    stepLenght = 320;
    LeftWidth = 61;
    LeftHeight = 42;
  }


  if (RightSecondAheadCounter == 2) {
    stepLenght = 300;
    RightWidth = 90;
    RightHeight = 52;
  }

  if (LeftSecondAheadCounter == 2) {
    LeftWidth = 62;
    LeftHeight = 36;
  }

  if (RightSecondAheadCounter == 3) {
    RightWidth = 60;
    RightHeight = 10;
  }

  if (LeftSecondAheadCounter == 3) {
    LeftWidth = 100;
    LeftHeight = 10;
  }
}


void lastWhistle() {
  if (distortionCounterRight>2) {
    whistle.play();
    mode = 18;
  }
}

