/*** Projected Footsteps ***
 * 
 * This Processing file is part of:
 * ROUTES, a project by Maria Gabriella Astolfo, Alberto Elizondo and Marco Righetto
 * http://www.interaction-venice.com/projects/iuav09-10Lab2/about/routes/
 * 
 * IUAV University of Venice - Design&Arts Faculty
 * IxD Lab 2 - January-April 2010
 * 
 * Tutors: Philip Tabor and Gillian Crampton-Smith
 * Thanks to Tom Hulbert and Durrel Bishop
 * 
 ***/


////////////////////ARDUINO COMMUNICATION/////////////
import processing.serial.*;

Serial port;
String buff = "";
int NEWLINE = 10;
String data;
int[] data_list; 
//////////////////////////////////////////////////////


/////////////////////////////////////////////////////
//////////////FOOTSTEPS DIMENSIONS AND POSITIONS/////
/////////////////////////////////////////////////////
int stepLenght = 160;
int LeftX = 93;
int LeftY = 365;
int RightX = 93;
int RightY = 365+40;
int LeftWidth= 31;
int RightWidth = 31;
int LeftHeight =  25;
int RightHeight = 25;
PImage left;
PImage right;
////////////////////////////////////////////////////


////////////////////////////////////////////////////
//////////////FOOTSTEPS ID VARIABLES///////////////
///////////////////////////////////////////////////
int rotationFrontBack;
boolean rotationFB = false;
boolean rotationBF = false;
int LeftSecondAheadCounter = 0;
int RightSecondAheadCounter = 0;
int distortionCounterLeft = 0;
int distortionCounterRight = 0;
int distortionBackRightCounter = 1;
int distortionBackLeftCounter = 1;

//////////////////////////////////////////////////


/////////////////////////////////////////////////////////
//////////// FINAL WHISTLE ACTIVATION VARIABLES//////////
/////////////////////////////////////////////////////////
boolean finalWhistle = false;
int finalWhistleTime;
int finalWhistleDelay = 1800;
int whistleCounter = 1;
boolean timeToWhistleActv = false;
long timeToWhistle;
long whistleDelay = 2000;
///////////////////////////////////////////////////


//////DIMMING VARS////
int LeftDim;
int RightDim;

//MODE
int mode = 0;


///ROTATION
float grads = 45;
float rad = radians(grads);


//////////////////////////////////////////////////////////////////////
/////////////////////////////////AUDIO PARTS/////////////////////////
//////////////////////////////////////////////////////////////////////
import krister.Ess.*;
AudioChannel audio;
AudioChannel whistle;
AudioChannel audio2;
AudioChannel audio3;
AudioChannel auch1;
AudioChannel auch2;
AudioChannel auch3;

FFT myFFT;
int bufferSize;
int bufferDuration;
//////////////////////////////////////////////////////////////////////


void setup() {
  size(800, 600);
  background(0);
  left = loadImage("left.png");
  right = loadImage("right.png");

  ////AUDIO 
  Ess.start(this);
  audio=new AudioChannel("panned_Left1.mp3");
  audio2=new AudioChannel("panned_Left1.mp3");
  audio3=new AudioChannel("panned_Left1.mp3");
  myFFT=new FFT(512);
  whistle = new AudioChannel ("whistleblowhere.wav");
  auch1 = new AudioChannel("auchFirst.mp3");
  auch2 = new AudioChannel ("auchSecond.mp3");
  auch3 = new AudioChannel ("auchThird.mp3");


  ////////////ARDUINO CONNECTION
  data = "0,0";
  println("Available serial ports:");
  println(Serial.list());
  port = new Serial(this, Serial.list()[0], 9600); 
}




